# SOlib major and minor version
%define major		2
%global minor		2
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

Name:		levmar
Version:	2.6
Release:	%mkrel 4
Summary:	Levenberg-Marquardt nonlinear least squares algorithm
License:	GPLv2+
Group:		Development/C
URL:		http://users.ics.forth.gr/~lourakis/levmar/

Source0:	http://users.ics.forth.gr/~lourakis/levmar/levmar-%{version}.tgz

# Patch to fix compilation of the shared library and compile the demo program
# Sent to levmar author on 28-Jan-2010
Patch0:		levmar-shared.patch

BuildRequires:	dos2unix
BuildRequires:	lapack-devel

%description
levmar is a native ANSI C implementation of the Levenberg-Marquardt
optimization algorithm.  Both unconstrained and constrained (under linear
equations, inequality and box constraints) Levenberg-Marquardt variants are
included.  The LM algorithm is an iterative technique that finds a local
minimum of a function that is expressed as the sum of squares of nonlinear
functions.  It has become a standard technique for nonlinear least-squares
problems and can be thought of as a combination of steepest descent and the
Gauss-Newton method.  When the current solution is far from the correct on,
the algorithm behaves like a steepest descent method: slow, but guaranteed
to converge.  When the current solution is close to the correct solution, it
becomes a Gauss-Newton method.

#------------------------------------------------

%package -n	%{libname}
Summary:	Levenberg-Marquardt nonlinear least squares algorithm
Group:		System/Libraries
Provides:	%{name} = %{version}-%{release}
Obsoletes:	%{name} < 2.5-13

%description -n	%{libname}
levmar is a native ANSI C implementation of the Levenberg-Marquardt
optimization algorithm.  Both unconstrained and constrained (under linear
equations, inequality and box constraints) Levenberg-Marquardt variants are
included.  The LM algorithm is an iterative technique that finds a local
minimum of a function that is expressed as the sum of squares of nonlinear
functions.  It has become a standard technique for nonlinear least-squares
problems and can be thought of as a combination of steepest descent and the
Gauss-Newton method.  When the current solution is far from the correct on,
the algorithm behaves like a steepest descent method: slow, but guaranteed
to converge.  When the current solution is close to the correct solution, it
becomes a Gauss-Newton method.

#------------------------------------------------

%package -n	%{develname}
Summary:	Development files for levmar library, and demo program
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{name}-devel < 2.5-13

%description -n	%{develname}
Development files for the levmar library, and demo program.

#------------------------------------------------

%prep
%setup -q
%patch -P 0 -p1 -b .shared
dos2unix -k README.txt

%build
mkdir sobj
%make_build CFLAGS="%{optflags} -funroll-loops -fPIC" -f Makefile.so

%install
install -D -p -m 755 sobj/liblevmar.so.%{major}.%{minor} %{buildroot}%{_libdir}/liblevmar.so.%{major}.%{minor}
install -D -p -m 644 levmar.h %{buildroot}%{_includedir}/levmar.h
install -D -p -m 755 lmdemo %{buildroot}%{_bindir}/lmdemo
ln -s liblevmar.so.%{major}.%{minor} %{buildroot}%{_libdir}/liblevmar.so.%{major}
ln -s liblevmar.so.%{major}.%{minor} %{buildroot}%{_libdir}/liblevmar.so

%files -n %{libname}
%doc README.txt LICENSE
%{_libdir}/liblevmar.so.%{major}.%{minor}
%{_libdir}/liblevmar.so.%{major}

%files -n %{develname}
%{_includedir}/levmar.h
%{_libdir}/liblevmar.so
%{_bindir}/lmdemo


%changelog
* Thu Mar 17 2022 umeabot <umeabot> 2.6-4.mga9
+ Revision: 1797261
- Mageia 9 Mass Rebuild

* Thu Feb 13 2020 umeabot <umeabot> 2.6-3.mga8
+ Revision: 1513884
- Mageia 8 Mass Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 2.6-2.mga7
+ Revision: 1298737
- Mageia 7 Mass Rebuild

* Sun Oct 08 2017 daviddavid <daviddavid> 2.6-1.mga7
+ Revision: 1170101
- new version: 2.6
- libify packages

* Mon Feb 08 2016 umeabot <umeabot> 2.5-12.mga6
+ Revision: 945188
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 2.5-11.mga5
+ Revision: 746826
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.5-10.mga5
+ Revision: 681304
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 2.5-9.mga4
+ Revision: 506889
- Mageia 4 Mass Rebuild

* Sat Jan 12 2013 umeabot <umeabot> 2.5-8.mga3
+ Revision: 356755
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Jun 17 2012 shlomif <shlomif> 2.5-7.mga3
+ Revision: 261315
- Correct group
- Mageia Cleanups
- Imported from Fedora RawHide


* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Jan 28 2010 Eric Smith <eric@brouhaha.com> - 2.5-4
- preserve timestamp of README in prep

* Sun Jan 24 2010 Eric Smith <eric@brouhaha.com> - 2.5-3
- don't need f2c
- spec cleanup based on review comments from Jussi Lehtola

* Sat Jan 23 2010 Eric Smith <eric@brouhaha.com> - 2.5-2
- spec cleanup based on review comments from Jussi Lehtola

* Fri Jan 22 2010 Eric Smith <eric@brouhaha.com> - 2.5-1
- initial version
